// GTW //
// Define shockwave characteristics for vehicle pad //
datablock ShockwaveData(VehiclePadShockwave)
{
   width = 30;
   numSegments = 30;
   numVertSegments = 2;
   velocity = 8;
   acceleration = 20.0;
   lifetimeMS = 6000;
   height = 1.0;
   verticalCurve = 0.5;

   mapToTerrain = false;
   renderBottom = true;

   texture[0] = "special/shockwave4";
   texture[1] = "special/gradient";
   texWrap = 6.0;

   times[0] = 0.0;
   times[1] = 0.5;
   times[2] = 1.0;

   colors[0] = "0.3 0.5 0.7 1.00";
   colors[1] = "0.5 0.7 1.0 0.20";
   colors[2] = "1.0 1.0 1.0 0.00";
};

// GTW //
// Define VehiclePad Explosion //
datablock ExplosionData(VehiclePadExplosion)
{
 explosionShape = "disc_explosion.dts"; // Need to make a BIG explosion to replace this
 soundProfile = MortarExplosionSound; // Make a boomier sound later
 faceViewer = true;
 shockwave = VehiclePadShockwave;
};

// GTW //
// Damage profile for vehicle pad //
datablock StaticShapeData(StationVehiclePad) : StaticShapeDamageProfile
{
   className = Station;
   catagory = "Stations";
   shapeFile = "vehicle_pad.dts";
   maxDamage = 1.20;
   destroyedLevel = 1.20;
   disabledLevel = 0.84;
   explosion      = VehiclePadExplosion;  // gtw defined at top
	expDmgRadius = 10.0;
	expDamage = 0.4;
	expImpulse = 1500.0;
   dynamicType = $TypeMasks::StationObjectType;
	isShielded = true;
	energyPerDamagePoint = 0.1;
	maxEnergy = 800;
	rechargeRate = 5;
   humSound = StationVehicleHumSound;
	// don't let these be damaged in Siege missions
	noDamageInSiege = true;

//   cmdCategory = "Support";
//   cmdIcon = CMDVehicleStationIcon;
//   cmdMiniIconName = "commander/MiniIcons/com_vehicle_pad_inventory";
//   targetTypeTag = 'Vehicle Station';

   debrisShapeName = "debris_generic.dts";
   debris = StationDebris;
};

///////// - GTW - ////////////////////////////////////////////////////
/////// make v-pad fully destroyable //////////////////////////////////
/////////////////////////////////////////////////////- GTW - //////////
function StationVehiclePad::onDestroyed(%data, %obj, %prevState)
{
   //%obj.trigger.delete();
   //decrement team deployed count.
   //$TeamDeployedCount[%obj.team, Inventory]--;  ???????????

   // when a station is destroyed, don't need trigger anymore
   %obj.schedule(700, "delete");
   // update the MIS file on the server
   // %game.saveMisFile(); // REMOVED FOR DEMO
   Parent::onDestroyed(%data, %obj, %prevState);
}
